"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BooyaLoader = /*#__PURE__*/function () {
  function BooyaLoader() {
    var _this = this;

    _classCallCheck(this, BooyaLoader);

    this.ready(function () {
      _this.initJQuery(_this.initBooya);
    });
  }

  _createClass(BooyaLoader, [{
    key: "ready",
    value: function ready(callback) {
      if (document.readyState !== 'loading') {
        callback();
      } else {
        document.addEventListener('DOMContentLoaded', callback);
      }
    }
  }, {
    key: "initJQuery",
    value: function initJQuery(callback) {
      var j = window.jQuery,
          jQueryVersion = j && j.fn && j.fn.jquery;

      if (jQueryVersion) {
        callback();
      } else {
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.src = 'https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js';

        script.onload = function () {
          callback();
        };

        (document.getElementsByTagName("head")[0] || document.documentElement).appendChild(script);
      }
    }
  }, {
    key: "initBooya",
    value: function initBooya() {
      var appID = window.booyaConfig && window.booyaConfig.appID || null,
          portalID = window.booyaConfig && window.booyaConfig.portalID || null,
          mode = window.booyaConfig && window.booyaConfig.__mode || 'live'; // Auto detect brix environment from brix elements

      if (window.booyaConfig.__product !== 'brix' && ($('#brix-booya-signin').length || $('#brix-booya-user-widget').length || $('.brix-dashboard-object-wrapper').length)) {
        window.booyaConfig.__product = 'brix';
        window.booyaConfig.__platform = 'hubspot';
      }

      function injectScripts() {
        var version = window.booyaConfig && window.booyaConfig.__version || 'latest';
        var dateNow = new Date(),
            cacheTag = "".concat(dateNow.getFullYear(), "-").concat(dateNow.getMonth(), "-").concat(dateNow.getDate(), "@").concat(dateNow.getHours());
        var head = $('head'); // Add Booya CSS

        var link = document.createElement('link');
        link.rel = 'stylesheet';
        link.href = mode === 'local-assets' ? '../dist/css/booya.css' : "https://cdn.jsdelivr.net/npm/@inboundlabs/booya-ui@".concat(version, "/dist/css/booya.min.css?ctag=").concat(encodeURIComponent(cacheTag));
        var title = head.find('title');

        link.onload = function () {
          // Add Booya JS
          var script = document.createElement('script');
          script.type = 'text/javascript';
          script.src = mode === 'local-assets' ? '../dist/js/booya.js' : "https://cdn.jsdelivr.net/npm/@inboundlabs/booya-ui@".concat(version, "/dist/js/booya.min.js?ctag=").concat(encodeURIComponent(cacheTag));
          head.append(script);
        };

        if (title.length) {
          title.after(link);
        } else {
          head.prepend(link);
        }
      }

      if (appID || portalID) {
        $.ajax({
          url: "".concat(mode === 'development' ? 'http://localhost:5000' : 'https://auth.booya.io').concat(appID ? "/".concat(appID, "/config") : "/config/".concat(portalID), "?version=").concat(window.booyaConfig.__version || '', "&platform=").concat(window.booyaConfig.__platform || '', "&product=").concat(window.booyaConfig.__product || '', "&url=").concat(encodeURIComponent(location.href)),
          type: "GET",
          dataType: 'json',
          xhrFields: {
            withCredentials: true
          }
        }).done(function (data) {
          window.booyaConfig = _objectSpread(_objectSpread(_objectSpread({}, window.booyaConfig || {}), data), {}, {
            __setup: true
          });
          injectScripts();
        }).fail(function (error) {
          if (error && error.responseText) {
            var data = $.parseJSON(error.responseText);

            if (data) {
              if (data.reason === 'not_setup') {
                window.booyaConfig = _objectSpread(_objectSpread({}, window.booyaConfig || {}), {}, {
                  __setup: false
                });
              }

              if (data.__version) {
                window.booyaConfig = _objectSpread(_objectSpread({}, window.booyaConfig || {}), {}, {
                  __version: data.__version
                });
              }
            }
          }

          injectScripts();
        });
      }

      window.addEventListener('message', function (event) {
        var _ref = event && event.data || {},
            eventType = _ref.type,
            eventName = _ref.eventName,
            formID = _ref.id;

        if (eventType === 'hsFormCallback' && eventName === 'onFormReady' && formID) {
          var user = window.user || null;

          if (user && user.email) {
            // Set email for hubspot form
            var setHubSpotFormEmails = function setHubSpotFormEmails() {
              var emailInputSelector = "form#hsForm_".concat(formID, ".hs-form .hs-form-field.hs-email input.hs-input[type=\"email\"]");
              $(emailInputSelector, $('.hbspt-form iframe.hs-form-iframe').contents()).val(user.email);
              $(emailInputSelector).val(user.email);
            };

            setHubSpotFormEmails();
            setTimeout(setHubSpotFormEmails, 200);
          }
        }
      });
    }
  }]);

  return BooyaLoader;
}();

if (!window.booya) {
  var setConfig = function setConfig(config) {
    if (!window.booyaConfig) window.booyaConfig = {};
    window.booyaConfig = _objectSpread(_objectSpread(_objectSpread({}, window.booyaConfig || {}), config || {}), {}, {
      overrides: _objectSpread(_objectSpread({}, window.booyaConfig && window.booyaConfig.overrides || {}), config && config.overrides || {})
    });
  };

  window.booya = {
    setConfig: setConfig,
    overrideConfig: function overrideConfig(config) {
      setConfig({
        overrides: config
      });
    },
    ready: function ready(callback) {
      if (!window.booyaQueue) window.booyaQueue = [];
      window.booyaQueue.push(callback);
    }
  };
  new BooyaLoader();
}
//# sourceMappingURL=booya-loader.js.map